#include <iostream>
#include <fstream>
#include <string>
#include <TH1F.h>
#include <TFile.h>
#include <sstream>
#include <cstring>
#include <cstdlib>

#define TAB '\t'
#define SINGLE_PADDING 5e-9
#define SUB_PADDING 5e-10

using namespace std;

int main(int argc, char *argv[]){
	if(argc<7){
		cout << "usage: make_hists file1 height1 time1 file2 height2 time2" << endl;
		return -1;
	}
	
	ifstream in1(argv[1]), in2(argv[4]);
	
	float b1, b2, n1, n2, m1, m2, t1, t2, s1, s2;
	string line1, line2;
	istringstream str1, str2;
	
	getline(in1, line1);
	getline(in2, line2);
	
	TH1F time1("time1","time1",100,atof(argv[3])-SINGLE_PADDING,atof(argv[3])+SINGLE_PADDING);
	TH1F time2("time2","time2",100,atof(argv[6])-SINGLE_PADDING,atof(argv[6])+SINGLE_PADDING);
	TH1F height1("height1","height1",100,0,atof(argv[2])+0.01);
	TH1F height2("height2","height2",100,0,atof(argv[5])+0.01);
	TH1F tof("tof","tof",100,atof(argv[6])-atof(argv[3])-SUB_PADDING,atof(argv[6])-atof(argv[3])+SUB_PADDING);
	
	while(!(in1.eof() || in2.eof())){
		getline(in1, line1);
		getline(in2, line2);
		
		str1.clear(); str2.clear();
		str1.str(line1); str2.str(line2);
		
		str1 >> b1 >> n1 >> m1 >> t1 >> s1;
		str2 >> b2 >> n2 >> m2 >> t2 >> s2;
		
		height1.Fill(-m1);
		height2.Fill(-m2);
		time1.Fill(t1);
		time2.Fill(t2);
		tof.Fill(t2-t1);
	}
	
	ostringstream str;
	
	str << argv[1] << ".root";
	
	cout << str.str() << endl;
	
	TFile file(str.str().c_str(), "recreate");
	height1.Write();
	height2.Write();
	time1.Write();
	time2.Write();
	tof.Write();
}
