#include <iostream>
#include <fstream>
#include <string>
#include <TH1F.h>
#include <TFile.h>
#include <sstream>
#include <cstring>
#include <cstdlib>

#define TAB '\t'
#define SINGLE_PADDING 2e-9
#define SUB_PADDING 5e-10

using namespace std;

int main(int argc, char *argv[]){
	if(argc<9){
		cout << "usage: make_hists_with_bounds file1 heightmin1 heightmax1 time1 file2 heightmin2 heightmax2 time2" << endl;
		return -1;
	}
	
	ifstream in1(argv[1]), in2(argv[5]);
	
	float heightmin1=atof(argv[2]), heightmax1=atof(argv[3]), heightmin2=atof(argv[6]), heightmax2=atof(argv[7]), timemed1=atof(argv[4]), timemed2=atof(argv[8]);
	
	float b1, b2, n1, n2, m1, m2, t1, t2, s1, s2;
	string line1, line2;
	istringstream str1, str2;
	
	getline(in1, line1);
	getline(in2, line2);
	
	TH1F time1("time1","time1",100,timemed1-SINGLE_PADDING,timemed1+SINGLE_PADDING);
	TH1F time2("time2","time2",100,timemed2-SINGLE_PADDING,timemed2+SINGLE_PADDING);
	TH1F height1("height1","height1",100,heightmin1,heightmax1);
	TH1F height2("height2","height2",100,heightmin2,heightmax2);
	TH1F tof("tof","tof",100,timemed2-timemed1-SUB_PADDING,timemed2-timemed1+SUB_PADDING);
	
	while(!(in1.eof() || in2.eof())){
		getline(in1, line1);
		getline(in2, line2);
		
		str1.clear(); str2.clear();
		str1.str(line1); str2.str(line2);
		
		str1 >> b1 >> n1 >> m1 >> t1 >> s1;
		str2 >> b2 >> n2 >> m2 >> t2 >> s2;
		
		if(-m1 < heightmin1 || -m1> heightmax1 || -m2 < heightmin2 || -m2 > heightmax2)
			continue;
		
		height1.Fill(-m1);
		height2.Fill(-m2);
		time1.Fill(t1);
		time2.Fill(t2);
		tof.Fill(t2-t1);
	}
	
	ostringstream str;
	
	str << argv[1] << ".root";
	
	cout << str.str() << endl;
	
	TFile file(str.str().c_str(), "recreate");
	height1.Write();
	height2.Write();
	time1.Write();
	time2.Write();
	tof.Write();
}
