#include <iostream>
#include <fstream>
#include <string>
#include <TH1F.h>
#include <TFile.h>
#include <sstream>

#define TAB '\t'
#define SINGLE_PADDING 5e-9
#define SUB_PADDING 5e-10

using namespace std;

int main(int argc, char *argv[]){
	if(argc<3){
		cout << "need two filenames." << endl;
		return -1;
	}
	
	ifstream in1(argv[1]), in2(argv[2]);
	
	float b1, b2, n1, n2, m1, m2, t1, t2, s1, s2;
	string line1, line2;
	istringstream str1, str2;
	
	getline(in1, line1);
	getline(in2, line2);
	
	float time1, time2;
	string filename, name1, name2, namesub;
	
	cin >> filename >> name1 >> name2 >> namesub >> time1 >> time2;
	
	TH1F hist1(name1.c_str(),name1.c_str(),100,time1-SINGLE_PADDING,time1+SINGLE_PADDING);
	TH1F hist2(name2.c_str(),name2.c_str(),100,time2-SINGLE_PADDING,time2+SINGLE_PADDING);
	TH1F histsub(namesub.c_str(),namesub.c_str(),100,time2-time1-SUB_PADDING,time2-time1+SUB_PADDING);
	
	while(!(in1.eof() || in2.eof())){
		getline(in1, line1);
		getline(in2, line2);
		
		str1.clear(); str2.clear();
		str1.str(line1); str2.str(line2);
		
		str1 >> b1 >> n1 >> m1 >> t1 >> s1;
		str2 >> b2 >> n2 >> m2 >> t2 >> s2;
		
		hist1.Fill(t1);
		hist2.Fill(t2);
		histsub.Fill(t2-t1);
	}
	
	TFile file(filename.c_str(), "recreate");
	hist1.Write();
	hist2.Write();
	histsub.Write();
}
